#ifndef __3DFACET_CPP__

#define __3DFACET_CPP__

#include "include.cpp"

#include "abstract.cpp"
#include "3Dmathdef.cpp"


class Facet
{
public:

  Triangle * tr;
  XColor xc;
  int tex;

    Facet ()
  {
  }
  Facet (Triangle * tr1, XColor c)
  {
    tr = tr1;
    xc = c;
  }

  void draw (int edge = 0, int fill = 1)
  {

    int x1, x2, x3, C, y1, y2, y3;
    float c;

    tran3d_2d (*(tr->pts[0]), x1, y1);
    tran3d_2d (*(tr->pts[1]), x2, y2);
    tran3d_2d (*(tr->pts[2]), x3, y3);


    if (edge)
      {
	setColor (0xffff - xc.red, 0xffff - xc.green, 0xffff - xc.blue);
	drawLine (x1, y1, x2, y2);
	drawLine (x1, y1, x3, y3);
	drawLine (x2, y2, x3, y3);
      }
    if (fill)
      {
	float c = (lightSrc.DotProduct (tr->normal) + 1) / 2;
	int C = int ((0x7000) * c);
	setColor (int (xc.red + C), int (xc.green + C), int (xc.blue + C));
	fillTriangle (x1, y1, x2, y2, x3, y3);
      }


    refresh ();

  }

  void print ()
  {
    tr->print ();
    cout << endl
      << "Color: RGB(" << xc.red << "," << xc.green << "," << xc.blue << ")";
  }

  void printOn (ostream & o)
  {
    tr->printOn (o);
    o << endl
      << "Color: RGB(" << xc.red << "," << xc.green << "," << xc.blue << ")";
  }

  int operator != (Facet f)
  {
    return ((xc.red != f.xc.red) ||
	    (xc.green != f.xc.green) ||
	    (xc.blue != f.xc.blue) || (*tr != *(f.tr)));
  }

};



     /* clip(Triangle t, Plane clip_p)
        {
        int in_out[3];
        int i,in,out;in=out=0;
        for(i=0;i<3;i++)
        {
        in_out[i]=t.pts[i].onWhatSide(p);
        if (in_out[i]== 0 ) { out++;}
        else {in++;}
        }



        if ( (in == 2) && (out==1) )
        {

        for(int i=0;i<3;i++)
        {
        if(in_out[i]==0) 
        {
        // find  pt that is outside -- say t.pts[k]
        // let other pts be t.pts[m] & t.pts[n]
        Line line_km(t.pts[i] , t.pts[(i+4)%3]);
        Line line_kn(t.pts[i] , t.pts[(i+2)%3]);
        break;
        }

        }

        Point p1 = ptLinePlane(line_km,clip_p);
        Point p2 = ptLinePlane(line_kn,clip_p);
        //return array of triangles -- Triangle(p1,p2,t.pts[(i+2)%3]),Triangle(t.pts[(i+4)%3],t.pts[(i+2)%3],p2);

        }
        if ( (in==1) && (out == 2) )
        {
        for(int i=0;i<3;i++)
        {
        if(in_out[i]==1) 
        {

        Line line_km(t.pts[(i+4)%3], t.pts[i]);
        Line line_kn(t.pts[(i+2)%3], t.pts[i]);
        break;
        }

        }
        Point p1 = ptLinePlane(line_km,clip_p);
        Point p2 = ptLinePlane(line_kn,clip_p);

        //  return Triangle(t.pts[i],p1,p2), pk is the inside pt
        } 


        if (in == 3 ) {return t;}
        if ( 3 - out ) { }

        }
      */


/*   texture(Point p, Point m , Point n)
     {
       int sx,sy;int tsize=100;
       Point o,h,v;

       o.x = n.x* p.y - n.y*p.x;
       o.y = m.x* p.y - m.y*p.x;
       o.z = n.x* m.y - n.y*m.x;

       h.x = n.y* p.z - n.z*p.y;
       h.y = m.y* p.z - m.z*p.y;
       h.z = n.y* m.z - m.y*n.z;

       v.x = n.z* p.x - n.x*p.z;
       v.y = m.z* p.x - m.x*p.z;
       v.z = n.z* m.x - n.x*m.z;

	if(p1.dist>p2.dist)
	     {
		Point t=p1;p1=p2;p2=t;
	     }
	else
            {
             pt=p1;	
             m=Vector( p2.x - p1.x, p2.y - p1.y , p2.z - p1.z);
	     m=m.Normalise();
             }
 
     }
         


*/







#endif //The very last line. Type everything before this line.
