#ifndef __SPHERE_CPP__

#define __SPHERE_CPP__

#include "include.cpp"

#include "3Dmathdef.cpp"
#include "3Dfacet.cpp"
#include "obj3D.cpp"



//list<Facet>* 
Object3D *
getCordSphere (float radius, XColor col, int st = 12)
{

  Point *pt1, *pt2, *pt3, *pt4, *Op, *Ap;
  Facet *f1, *f2;
  Triangle *t1, *t2;
  list < Triangle > *Trilist = new list < Triangle >;
  list < Facet > *Facetlist = new list < Facet >;
  float step = M_PI / st;
  list < Point > *ptlist = new list < Point >[int (st) + 1];
  float t = 0;
  int i = 0, j = 0;
  int n = 0;

  i = 0;
  for (float a = -M_PI_2; a <= M_PI_2 && i <= st; a += step)
    {
      if (t == 0)
	t = step / 2;
      else
	{
	  t = 0;
	}
      int c = 0;
      if (int (a * 100) == int (-M_PI_2 * 100))
	{
	  pt1 = new Point (0, -radius, 0);
	  pt1 = ptlist[i].insInRear (pt1);
	}
      else if (int (a * 100) == int (M_PI_2 * 100))
	{
	  pt1 = new Point (0, radius, 0);
	  pt1 = ptlist[i].insInRear (pt1);
	}
      else
	{
	  for (float b = 0; b <= 2 * M_PI; b += step)
	    {
	      pt1 =
		new Point (radius * cos (a) * cos (b + t), radius * sin (a),
			   radius * sin (b + t) * cos (a));
	      pt1 = ptlist[i].insInRear (pt1);
	    }
	}
      i++;
    }
  pt1 = new Point (0, radius, 0);
  pt1 = ptlist[st].insInRear (pt1);


  Point *p1, *p2, *p3;

  n = int (2 * st);

  for (j = 0; j < n; j++)
    {
      p1 = ptlist[0][0];
      p2 = ptlist[1][j];
      p3 = ptlist[1][(j + 1) % n];
      Triangle *tr = new Triangle (p2, p1, p3);
      tr = Trilist->insInRear (tr);
      Facet *f1 = new Facet (tr, col);
      f1 = Facetlist->insInRear (f1);
    }


  for (i = 1; i < st - 1; i++)
    {
      for (j = 0; j < n; j++)
	{
	  p1 = ptlist[i][j];
	  p2 = ptlist[i][(j + 1) % n];
	  if (i % 2)
	    p3 = ptlist[i + 1][j];
	  else
	    p3 = ptlist[i + 1][(j + 1) % n];
	  Triangle *tr = new Triangle (p1, p2, p3);
	  tr = Trilist->insInRear (tr);
	  Facet *f1 = new Facet (tr, col);
	  f1 = Facetlist->insInRear (f1);
	  if (i % 2)
	    p1 = ptlist[i + 1][(j + 1) % n];
	  else
	    p1 = ptlist[i + 1][(j + 2) % n];
	  tr = new Triangle (p1, p3, p2);
	  tr = Trilist->insInRear (tr);
	  f1 = new Facet (tr, col);
	  f1 = Facetlist->insInRear (f1);
	}
    }


  for (j = 0; j < n; j++)
    {
      p1 = ptlist[st][0];
      p2 = ptlist[st - 1][j];
      p3 = ptlist[st - 1][(j + 1) % n];
      Triangle *tr = new Triangle (p1, p2, p3);
      tr = Trilist->insInRear (tr);
      Facet *f1 = new Facet (tr, col);
      f1 = Facetlist->insInRear (f1);
    }



/*
	for(int i=0;i<st+1;i++)
	{
		int cnt1=ptlist[i].getCount();
		cout<<"\n\n\n point list no::"<<i+1;
		ptlist[i].rewind();
		for(int j=0;j<cnt1;j++)
		{
		 Point *pt =new Point(); pt=ptlist[i].get();pt->print();
		}
	}
	
   cout << endl << "****Number Of Facets: " << Facetlist->getCount();
    cout << endl << "****Number Of Triangles: " << Trilist->getCount();*/

  Object3D *sphere = new Object3D;
  list < Point > *oplist = new list < Point >;
  for (i = 0; i <= st; i++)
    {
      for (j = 0; j < ptlist[i].getCount (); j++)
	{
	  oplist->insInRear (ptlist[i][j]);
	}
    }
  sphere->PointList = oplist;
  sphere->TriangleList = Trilist;
  sphere->FacetList = Facetlist;
  return sphere;
}


#endif
