#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <iostream.h>
#include <errno.h>



#ifdef __XXX__
#include "../include.cpp"
#include "netdef.cpp"
#else
#define MSG_PORT 3000
#define INFO_PORT 5000
#endif




int sendData(void* data, int len, struct in_addr where)
{
	sockaddr_in fromAddr, toAddr;
	toAddr.sin_addr=where;
	toAddr.sin_family=AF_INET;
	toAddr.sin_port=htons(INFO_PORT);
	int sd = socket(AF_INET, SOCK_STREAM, 0);
	if( sd < 0 )
	{
		cerr << "\nsendData: Could not create Socket:";
		return sd;
	}
	fromAddr.sin_family = AF_INET;
	fromAddr.sin_port = htons(INFO_PORT);
	fromAddr.sin_addr.s_addr = htonl(INADDR_ANY);
	int rc = bind( sd, (sockaddr*)(&fromAddr), sizeof(fromAddr) );
	if( rc < 0 )
	{
		cerr << "\nsendData: Couldn't bind:";
		close(sd);
		return rc;
	}
	
	rc = connect( sd, (sockaddr*)(&toAddr), sizeof(toAddr) );
	if( rc < 0 )
	{
		cerr << "\nsendData: Couldn't connect:";
		close(sd);
		return rc;
	}

	rc = send( sd, data, len, 0);

	//rc = sendto( sd , data, len, 0, (sockaddr*)(&toAddr), sizeof(toAddr));

	if( rc < 0 )
	{
		cerr << "\nsendData: Couldn't send data:";
	}

	else if( rc < len )
	{
		cerr << "\nsendData: Couldn't send all data: Bytes sent:" << rc;
	}
	else
	cerr << "\nsendData: Data Sent Successfully:" << rc;
	
	if( close(sd)<0)
		cerr << "\nsendData: Close Failed:"
		     << strerror(errno);
	return rc;
}

int sendDataNC(void* data, int len, struct in_addr where)
{
	sockaddr_in fromAddr, toAddr;
	toAddr.sin_addr=where;
	toAddr.sin_family=AF_INET;
	toAddr.sin_port=htons(INFO_PORT);
	int sd = socket(AF_INET, SOCK_STREAM, 0);
	if( sd < 0 )
	{
		cerr << "\nsendData: Could not create Socket:";
		return sd;
	}
	fromAddr.sin_family = AF_INET;
	fromAddr.sin_port = htons(INFO_PORT);
	fromAddr.sin_addr.s_addr = htonl(INADDR_ANY);
	int rc = bind( sd, (sockaddr*)(&fromAddr), sizeof(fromAddr) );
	if( rc < 0 )
	{
		cerr << "\nsendData: Couldn't bind:";
		close(sd);
		return rc;
	}
	/*
	rc = connect( sd, (sockaddr*)(&toAddr), sizeof(toAddr) );
	if( rc < 0 )
	{
		cerr << "\nsendData: Couldn't connect:";
		close(sd);
		return rc;
	}

	rc = send( sd, data, len, 0);
	*/
	rc = sendto( sd , data, len, 0, (sockaddr*)(&toAddr), sizeof(toAddr));

	if( rc < 0 )
	{
		cerr << "\nsendData: Couldn't send data:";
	}

	else if( rc < len )
	{
		cerr << "\nsendData: Couldn't send all data: Bytes sent:" << rc;
	}
	else
	cerr << "\nsendData: Data Sent Successfully:" << rc;
	
	if( close(sd)<0)
		cerr << "\nsendData: Close Failed:"
		     << strerror(errno);
	return rc;
}

int sendMsg(void *msg, int len, struct in_addr where)
{
	int sd, rc;
	sockaddr_in fromAddr, toAddr;
	toAddr.sin_addr=where;
	toAddr.sin_family=AF_INET;
	toAddr.sin_port=htons(MSG_PORT);
	sd = socket(AF_INET, SOCK_DGRAM, 0);
	if( sd < 0 )
	{
		cerr << "\nsendMsg: Could not create Socket:";
		return sd;
	}
	fromAddr.sin_family = AF_INET;
	fromAddr.sin_port = htons(MSG_PORT);
	fromAddr.sin_addr.s_addr = htonl(INADDR_ANY);
	rc = bind( sd, (sockaddr*)(&fromAddr), sizeof(fromAddr) );
	if( rc < 0 )
	{
		cerr << "\nsendMsg: Could not bind:";
		close(sd);
		return rc;
	}
	rc = sendto(sd,msg,len,0,(sockaddr*)(&toAddr),sizeof(toAddr));
	if( rc < 0 )
	{
		cerr << "\nsendMsg: Could not send:";
	}
	else if( rc < len )
	{
		cerr << "\nsendMsg: Not all Mesg sent: Bytes sent: "
		     << rc;
		close(sd);
		return rc;
	}
	else cerr << "\nsendMsg: Mesg sent successfully:";
	close(sd);
	return rc;
}

int recvMsg(void *msg, int len, struct in_addr *whosentit)
{
	int sd, rc;
	sd = socket(AF_INET, SOCK_DGRAM, 0);
	if( sd < 0 )
	{
		cerr << "\nrecvMsg: Couldn't create Socket:";
		return sd;
	}
	struct sockaddr_in f;
	struct sockaddr_in *fromAddr;
        struct sockaddr_in toAddr;
	fromAddr=&f;
	int slen=sizeof(f);
	toAddr.sin_addr.s_addr = htonl(INADDR_ANY);
	toAddr.sin_port = htons(MSG_PORT);
	toAddr.sin_family = AF_INET;
	rc = bind( sd, (sockaddr*)(&toAddr), sizeof(toAddr) );
	if( rc < 0 )
	{
		cerr << "\nrecvMsg: Couldn't bind:";
		close(sd);
		return rc;
	}

	rc = recvfrom( sd, msg, len, 0, (sockaddr*)fromAddr, (socklen_t*)&slen);
	if( rc < 0 )
	{
		cerr << "\nrecvMsg: Couldn't receive:";
	}
	if(fromAddr!=NULL)
	{
		*whosentit = fromAddr->sin_addr;
		cerr << "\nrecvFrom: From: " << inet_ntoa(fromAddr->sin_addr);
	}
	else whosentit=NULL;
	close(sd);
	cerr << "\nrecvMsg: Bytes received: " << rc;
	return rc;	
}
			

void* recvData(void *data, int *len, struct in_addr *whosentit)
{
	int sd, rc;
	*len=0;
	int blen=1024;
	char *buff=new char[blen];
	char *dt=NULL;
	struct sockaddr_in f;
	struct sockaddr_in toAddr, *fromAddr=NULL;
	int slen=sizeof(f);
	fromAddr=&f;

	sd = socket( AF_INET, SOCK_STREAM, 0 );
	if( sd < 0 )
	{
		cerr << "\nrecvData: Couldn't create socket:"
		     << strerror(errno);
		exit(errno);
	}

	toAddr.sin_family = AF_INET;
	toAddr.sin_addr.s_addr = htonl(INADDR_ANY);
				 //inet_addr("192.168.13.4");
	toAddr.sin_port = //htons(0);
			htons(INFO_PORT);
	
	/*
	cerr << "\nrecvData: toAddr.sin_addr.s_addr: "
	     << inet_ntoa(toAddr.sin_addr);*/

	rc = bind( sd, (sockaddr*)&toAddr, sizeof(toAddr) );

	if( rc < 0 )
	{
		cerr << "\nrecvData: Couldn't bind:"
		     << strerror(errno);
		close(sd);
		exit(errno);
	}
	else cerr << "\nrecvData: Bind Successful:";

	rc=listen(sd, 1);
	if(rc < 0)
	{
		cerr << "\nrecvData: Listen Failed:"
		     << strerror(errno);
		close(sd);
		exit(errno);
	}

	int oldSd=sd;
	sd = accept(sd,(sockaddr*)fromAddr,(socklen_t*)&slen);

	if(sd < 0)
	{
		cerr << "\nrecvData: Accept Failed:"
		     << strerror(errno);
		close(sd);
		close(oldSd);
		exit(errno);
	}
	cerr << "\nrecvData: Accept Successful:"
	     << "\nOld Sd = " << oldSd << "\nSd = " << sd;	

	rc=0;
	*len=0;
	data=NULL;

	bzero( buff, blen);
	while( (rc=recv(sd, buff, blen, 0)) > 0 )
	{
		dt=(char*)realloc(dt, *len + rc);
		if( dt == NULL )
		{
			cerr << "\nrecvData: realloc Failed:"
			     << strerror(errno);
			exit(errno);			
		}
		memcpy( dt + *(len), buff, rc);
		*len = *len + rc;
		bzero(buff,blen);
	}
	if( rc <= 0 )
	{
		cerr << "\nrecvData: No more data: Bytes received: "
		     << *len;
	}
	if(fromAddr!=NULL)
		*whosentit = fromAddr->sin_addr;
	else whosentit=NULL;
	data=new char[ *len ];
	memcpy(data,dt,*len);
	cerr << "\nrecvData: Dt :" << dt;
	if(close(sd)<0 ) 
		cerr << "\nrecvData: Close failed:"
		     << strerror(errno);
	if(close(oldSd)<0)
		cerr << "\nrecvData: Close failed:"
		     << strerror(errno);
	return data;
}

void* recvDataNC(void *data, int *len, struct in_addr *whosentit)
{
	int sd, rc;
	*len=0;
	int blen=1024;
	char *buff=new char[blen];
	char *dt=NULL;
	struct sockaddr_in f;
	struct sockaddr_in toAddr, *fromAddr=NULL;
	int slen=sizeof(f);
	fromAddr=&f;

	sd = socket( AF_INET, SOCK_STREAM, 0 );
	if( sd < 0 )
	{
		cerr << "\nrecvData: Couldn't create socket:"
		     << strerror(errno);
		exit(errno);
	}

	toAddr.sin_family = AF_INET;
	toAddr.sin_addr.s_addr = htonl(INADDR_ANY);
				 //inet_addr("192.168.13.4");
	toAddr.sin_port = //htons(0);
			htons(INFO_PORT);
	
	/*
	cerr << "\nrecvData: toAddr.sin_addr.s_addr: "
	     << inet_ntoa(toAddr.sin_addr);*/

	rc = bind( sd, (sockaddr*)&toAddr, sizeof(toAddr) );

	if( rc < 0 )
	{
		cerr << "\nrecvData: Couldn't bind:"
		     << strerror(errno);
		close(sd);
		exit(errno);
	}
	else cerr << "\nrecvData: Bind Successful:";
	
	rc=0;
	*len=0;
	data=NULL;

	bzero( buff, blen);
	while( (rc=recvfrom(sd, buff, blen, 0, (sockaddr*)fromAddr, (socklen_t*)&slen)) > 0 )
	{
		dt=(char*)realloc(dt, *len + rc);
		if( dt == NULL )
		{
			cerr << "\nrecvData: realloc Failed:"
			     << strerror(errno);
			exit(errno);			
		}
		memcpy( dt + *(len), buff, rc);
		*len = *len + rc;
		bzero(buff,blen);
	}
	if( rc <= 0 )
	{
		cerr << "\nrecvData: No more data: Bytes received: "
		     << *len;
	}
	if(fromAddr!=NULL)
		*whosentit = fromAddr->sin_addr;
	else whosentit=NULL;
	data=new char[ *len ];
	memcpy(data,dt,*len);
	cerr << "\nrecvData: Dt :" << dt;
	if(close(sd)<0 ) 
		cerr << "\nrecvData: Close failed:"
		     << strerror(errno);
	return data;
}
