#ifndef __PTR2VAR_CPP__RAM__

#define __PTR2VAR_CPP__RAM__


struct TriangleVars
{
	Point pt[3];
	void printOn(ostream& o)
	{
		o << endl << "Triangle"
		  << endl << "Vertex0" << "\t"
			  << pt[0].x << " " 
			  << pt[0].y << " "
			  << pt[0].z
		  << endl << "Vertex1" << "\t" 
			  << pt[1].x << " " 
			  << pt[1].y << " "
			  << pt[1].z
		  << endl << "Vertex2" << "\t"
			  << pt[2].x << " " 
			  << pt[2].y << " "
			  << pt[2].z
			  << endl << "EndTriangle";
	}
};

struct FacetVars
{
	TriangleVars tr;
	XColor xc;
	void printOn(ostream& o)
	{
		o << endl << "Facet"
		  << endl << "Color" << "\t"
		  << xc.red << " " 
		  << xc.green << " " 
		  << xc.blue << endl;
		tr.printOn(o);
		o << endl << "EndFacet";
	}
};

TriangleVars makeTriangleVar(Triangle *tr)
{
	TriangleVar tv;
	tv.pt[0]=*(tr->pts[0]);
	tv.pt[1]=*(tr->pts[1]);
	tv.pt[2]=*(tr->pts[2]);
	return tv;
}

FacetVars makeFacetVar(Facet *f)
{
	FacetVars fv;
	fv.tr = makeTriangleVar(f->tr);
	fv.xc = f->xc;
	return fv;
}


TriangleVars* makeTriangleVars(list<Triangle> *tl)
{
	tl->rewind();
	int cnt = tl->getCount();
	int i;
	TriangleVars *tv = new TriangleVars[cnt];
	Triangle* t;
	for(i=0;i<cnt;i++)
	{
		t=tl->get();
		tv[i].pt[0]=*(t->pts[0]);
		tv[i].pt[1]=*(t->pts[1]);
		tv[i].pt[2]=*(t->pts[2]);
	}
	return tv;
}

int makeFacetVars(list<Facet> *fl, FacetVars* fv)
{
	fl->rewind();
	int cnt=fl->getCount();
	int i;
	FacetVars *fv = new FacetVars[cnt];
	Facet *f;
	for(i=0;i<cnt;i++)
	{
		f=fl->get();
		fv[i].tr.pt[0]=*((f->tr)->pts[0]);
		fv[i].tr.pt[1]=*((f->tr)->pts[1]);
		fv[i].tr.pt[2]=*((f->tr)->pts[2]);
		fv[i].xc = f->xc;
	}
	return cnt;
}

int makeFacetList(FacetVars* fv, list<Facet> *fl);

int ma

#endif
