#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <iostream.h>
#include <errno.h>



#ifdef __XXX__
#include "../newest/include.cpp"
#include "netdef.cpp"
#else
#define MSG_PORT 3000
#define INFO_PORT 5000
#endif




int sendMsg(void *msg, int len, struct in_addr where, int port)
{
	int sd, rc;
	sockaddr_in fromAddr, toAddr;
	toAddr.sin_addr=where;
	toAddr.sin_family=AF_INET;
	toAddr.sin_port=htons(port);
	sd = socket(AF_INET, SOCK_DGRAM, 0);
	if( sd < 0 )
	{
		cerr << "\nsendMsg: Could not create Socket:";
		return sd;
	}
	fromAddr.sin_family = AF_INET;
	fromAddr.sin_port = htons(port);
	fromAddr.sin_addr.s_addr = htonl(INADDR_ANY);
	rc = bind( sd, (sockaddr*)(&fromAddr), sizeof(fromAddr) );
	if( rc < 0 )
	{
		cerr << "\nsendMsg: Could not bind:";
		close(sd);
		return rc;
	}
	rc = sendto(sd,msg,len,0,(sockaddr*)(&toAddr),sizeof(toAddr));
	if( rc < 0 )
	{
		cerr << "\nsendMsg: Could not send:";
	}
	else if( rc < len )
	{
		cerr << "\nsendMsg: Not all Mesg sent: Bytes sent: "
		     << rc;
		close(sd);
		return rc;
	}
	else cerr << "\nsendMsg: Mesg sent successfully:";
	close(sd);
	return rc;
}

int recvMsg(void *msg, int len, struct in_addr *whosentit, int port)
{
	int sd, rc;
	sd = socket(AF_INET, SOCK_DGRAM, 0);
	if( sd < 0 )
	{
		cerr << "\nrecvMsg: Couldn't create Socket:";
		return sd;
	}
	struct sockaddr_in f;
	struct sockaddr_in *fromAddr;
        struct sockaddr_in toAddr;
	fromAddr=&f;
	int slen=sizeof(f);
	toAddr.sin_addr.s_addr = htonl(INADDR_ANY);
	toAddr.sin_port = htons(port);
	toAddr.sin_family = AF_INET;
	rc = bind( sd, (sockaddr*)(&toAddr), sizeof(toAddr) );
	if( rc < 0 )
	{
		cerr << "\nrecvMsg: Couldn't bind:";
		close(sd);
		return rc;
	}

	rc = recvfrom( sd, msg, len, 0, (sockaddr*)fromAddr, (socklen_t*)&slen);
	if( rc < 0 )
	{
		cerr << "\nrecvMsg: Couldn't receive:";
	}
	if(fromAddr!=NULL)
	{
		*whosentit = fromAddr->sin_addr;
		cerr << "\nrecvFrom: From: " << inet_ntoa(fromAddr->sin_addr);
	}
	else whosentit=NULL;
	close(sd);
	cerr << "\nrecvMsg: Bytes received: " << rc;
	return rc;	
}
